#include <netdb.h>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <unistd.h>

char latest_version[21];

void *check_version (void *prog)
{
  char buf[80];
  char *p;
  int fd;
  int tmp;
  struct hostent *he;
  struct linger lng;
  struct sockaddr_in server;
  FILE *file;
  
  latest_version [0] = '\0';
  
  he = gethostbyname ("kfib.org");
  if (he == NULL) return NULL;
  
  memset ((char *) &server, 0, sizeof (server));
  memcpy ((char *) &server.sin_addr, he->h_addr, he->h_length);
  server.sin_family = he->h_addrtype;
  server.sin_port = htons (3906);
  
  fd = socket(AF_INET, SOCK_STREAM, 0);
  if (fd < 0) return NULL;
  
  lng.l_linger = 0;
  lng.l_onoff = 0;
  
  if (setsockopt (fd, SOL_SOCKET, SO_LINGER, &lng, sizeof(lng)) < 0)
    return NULL;
  
  tmp = 0;
  if (setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, &tmp, sizeof (tmp)) < 0)
    return NULL;
  
  tmp = 1;
  if (setsockopt(fd, SOL_SOCKET, SO_KEEPALIVE, &tmp, sizeof (tmp)) < 0)
    return NULL;
  
  if (connect (fd, (struct sockaddr *) &server, sizeof (server)) < 0)
    return NULL;
  
  file = fdopen (fd, "a+");
  if (file == NULL) return NULL;

  while (fgets (buf, 80, file))
    {
      p = strtok (buf, ":");
      if (!strcmp (p, (char *) prog))
	{
	  p = strtok (NULL, "\n");
	  if (strcmp (p, VERSION))
	    {
	      fclose (file);
	      close (fd);
	      strncpy (latest_version, p, 20);
	      latest_version[20] = '\0';
	      return NULL;
	    }
	}
    }
  
  fclose (file);
  close (fd);
  return NULL;
}
